- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Typedefs | Functions
Edje Perspective
Edje » Edje Object

Functions that deal with 3D projection of an 2D object. More...

## Typedefs
typedef struct _Edje_Perspective | Edje_Perspective

## Functions
Edje_Perspective * | edje_perspective_new (Evas *e)
| Creates a new perspective in the given canvas. More...
void | edje_perspective_free (Edje_Perspective *ps)
| Delete the given perspective object. More...
void | edje_perspective_set (Edje_Perspective *ps, Evas_Coord px, Evas_Coord py, Evas_Coord z0, Evas_Coord foc)
| Setup the transform for this perspective object. More...
void | edje_perspective_global_set (Edje_Perspective *ps, Eina_Bool global)
| Make this perspective object be global for its canvas. More...
Eina_Bool | edje_perspective_global_get (const Edje_Perspective *ps)
| Get whether the given perspective object is global or not. More...
const Edje_Perspective * | edje_evas_global_perspective_get (const Evas *e)
| Get the global perspective object set for this canvas. More...

## Detailed Description

Functions that deal with 3D projection of an 2D object.

Perspective is a graphical tool that makes objets represented in 2D look like they have a 3D appearance.

Edje allows us to use perspective on any edje object. This group of functions deal with the use of perspective, by creating and configuring a perspective object that must set to a edje object or a canvas, affecting all the objects inside that have no particular perspective set already.

## Function Documentation

Edje_Perspective* edje_perspective_new | ( | Evas * | e | ) |

Creates a new perspective in the given canvas.

Parameters

  e | The given canvas (Evas).

Returns
  An Edje Perspective object for this canvas, or `NULL` on errors.

This function creates a perspective object that can be set on an Edje object, or globally to all Edje objects on this canvas.

See also
  edje_perspective_set()
  edje_perspective_free()

Examples:
  edje-perspective.c.

References EVAS_CALLBACK_DEL, evas_object_data_set(), evas_object_event_callback_add(), and evas_object_rectangle_add().

void edje_perspective_free | ( | Edje_Perspective * | ps | ) |

Delete the given perspective object.

Parameters

  ps | A valid perspective object, or `NULL`.

This function will delete the perspective object. If the perspective effect was being applied to any Edje object or part, this effect won't be applied anymore.

See also
  edje_perspective_new()

References evas_object_del().

void edje_perspective_set | ( | Edje_Perspective * | ps,
|  | Evas_Coord | px,
|  | Evas_Coord | py,
|  | Evas_Coord | z0,
|  | Evas_Coord | foc
| ) |  |

Setup the transform for this perspective object.

This sets the parameters of the perspective transformation. X, Y and Z values are used. The px and py points specify the "infinite distance" point in the 3D conversion (where all lines converge to like when artists draw 3D by hand). The `z0` value specifies the z value at which there is a 1:1 mapping between spatial coordinates and screen coordinates. Any points on this z value will not have their X and Y values modified in the transform. Those further away (Z value higher) will shrink into the distance, and those less than this value will expand and become bigger. The `foc` value determines the "focal length" of the camera. This is in reality the distance between the camera lens plane itself (at or closer than this rendering results are undefined) and the "z0" z value. This allows for some "depth" control and `foc` must be greater than 0.

Parameters

  ps | The perspective object
  px | The perspective distance X coordinate
  py | The perspective distance Y coordinate
  z0 | The "0" z plane value
  foc | The focal distance

Examples:
  edje-perspective.c.

References EINA_LIST_FOREACH, and EINA_TRUE.

void edje_perspective_global_set | ( | Edje_Perspective * | ps,
|  | Eina_Bool | global
| ) |  |

Make this perspective object be global for its canvas.

Parameters

  ps | The given perspective object
  global | `EINA_TRUE` if the perspective should be global, `EINA_FALSE` otherwise.

The canvas which this perspective object is being set as global is the one given as argument upon the object creation (the `evas` parameter on the function `edje_perspective_new(evas)` ).

There can be only one global perspective object set per canvas, and if a perspective object is set to global when there was already another global perspective set, the old one will be set as non-global.

A global perspective just affects a part if its Edje object doesn't have a perspective object set to it, and if the part doesn't point to another part to be used as perspective.

See also
  edje_object_perspective_set()
  edje_perspective_global_get()
  edje_perspective_new()

Examples:
  edje-perspective.c.

References EINA_LIST_FOREACH, EINA_TRUE, and evas_object_name_find().

Eina_Bool edje_perspective_global_get | ( | const Edje_Perspective * | ps | ) |

Get whether the given perspective object is global or not.

Parameters

  ps | The given perspective object.

Returns
  `EINA_TRUE` if this perspective object is global, `EINA_FALSE` otherwise.

See also
  edje_perspective_global_set()

References EINA_FALSE.

const Edje_Perspective* edje_evas_global_perspective_get | ( | const Evas * | e | ) |

Get the global perspective object set for this canvas.

Parameters

  e | The given canvas (Evas).

Returns
  The perspective object set as global for this canvas. Or `NULL` if there is no global perspective set and on errors.

This function will return the perspective object that was set as global with edje_perspective_global_set().

See also
  edje_perspective_global_set()
  edje_perspective_global_get()

References evas_object_data_get(), and evas_object_name_find().